<?php

namespace App\Controllers\Admin\Equipment;

use App\Services\Customer\ServiceService;
use App\Services\Equipment\ServerService;
use CodeIgniter\HTTP\RedirectResponse;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class ServerController extends EquipmentController
{
  public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
  {
    parent::initController($request, $response, $logger);
    $this->content_title = lang("{$this->getService()->getClassName()}.title");
    $this->class_path .= $this->getService()->getClassName();
    $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
    // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;
  }
  public function getService(): ServerService
  {
    if (!$this->_service) {
      $this->_service = new ServerService();
    }
    return $this->_service;
  }
  //Index,FieldForm관련
  protected function getResultSuccess(string $message = MESSAGES["SUCCESS"], ?string $actionTemplate = null): RedirectResponse|string
  {
    switch ($this->getService()->getAction()) {
      case 'create_form':
      case 'modify_form':
      case 'index':
      case 'view':
        $this->service = $this->getService();
        $this->control = $this->getService()->getControlDatas();
        $this->getService()->getHelper()->setViewDatas($this->getViewDatas());
        $actionTemplate = $this->request->getVar('ActionTemplate') ?? $actionTemplate ?? 'server';
        if ($actionTemplate) {
          $view_file = $this->view_path . $actionTemplate . DIRECTORY_SEPARATOR . $this->getService()->getAction();
        } else {
          $view_file = $this->view_path . $this->getService()->getAction();
        }
        $result = view($view_file, ['viewDatas' => $this->getViewDatas()]);
        break;
      default:
        $result = parent::getResultSuccess($message, $actionTemplate);
        break;
    }
    return $result;
  }
  protected function create_form_process(): void
  {
    $formDatas = $this->getService()->getFormDatas();
    $formDatas['code'] = sprintf("%d%dXX-M%d", date("y"), ceil((int)date("m") / 3), $this->getService()->getLatestPK());
    $this->getService()->setFormDatas($formDatas);
    parent::create_form_process();
  }
}
